//+------------------------------------------------------------------+
//|                                                        iPCHs.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "http://dmffx.com"
#property link      "http://dmffx.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 MediumAquamarine
#property indicator_color2 MediumAquamarine
#property indicator_color3 MediumAquamarine

   /*
       PriceChannel  
   */

extern   int      PCHPeriod   =  34;   //   
extern   int      PCHPrice    =  2;    // : 0 - Close; 1 - Open; 2 -  High,  Low; 3 -  Low,  High
extern   int      SmPeriod    =  5;    //  
extern   int      SmMethod    =  0;    //  : 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern   int      Shift       =  0;    // 


int UpperMode,LowerMode,UpperPrice,LowerPrice;

//---- buffers
double hsm[];
double lsm[];
double c[];
double h[];
double l[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){

   fPriceHLCModePrice(PCHPrice,UpperMode,LowerMode,UpperPrice,LowerPrice);

//---- indicators

   IndicatorBuffers(5);

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,hsm);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,lsm);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,c);

   SetIndexBuffer(3,h);
   SetIndexBuffer(4,l);
   
   SetIndexShift(0,Shift);
   SetIndexShift(1,Shift);
   SetIndexShift(2,Shift);
   
   SetIndexLabel(0,"PCHsUpper");
   SetIndexLabel(1,"PCHsLower");
   SetIndexLabel(2,"PCHsMedian");
   
   SetIndexDrawBegin(0,PCHPeriod+fMADrawBegin(SmPeriod,SmMethod));
   SetIndexDrawBegin(1,PCHPeriod+fMADrawBegin(SmPeriod,SmMethod));   
   SetIndexDrawBegin(2,PCHPeriod+fMADrawBegin(SmPeriod,SmMethod)); 
   
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               h[i]=iMA(NULL,0,1,0,0,UpperPrice,iHighest(NULL,0,UpperMode,PCHPeriod,i));
               l[i]=iMA(NULL,0,1,0,0,LowerPrice,iLowest(NULL,0,LowerMode,PCHPeriod,i));
            }
            for(i=limit-1;i>=0;i--){
               hsm[i]=iMAOnArray(h,0,SmPeriod,0,SmMethod,i);
               lsm[i]=iMAOnArray(l,0,SmPeriod,0,SmMethod,i);
               c[i]=(hsm[i]+lsm[i])/2;
            }            

//----
   return(0);
  }
//+------------------------------------------------------------------+

void fPriceHLCModePrice(int aMode,int & aUpperMode, int & aLowerMode, int & aUpperPrice, int & aLowerPrice){
   // 0 - Close; 1 - Open; 2 -  High,  Low; 3 -  Low,  High
   switch(aMode){
      case 0:
         aUpperMode=MODE_CLOSE;
         aLowerMode=MODE_CLOSE;     
         aUpperPrice=PRICE_CLOSE;
         aLowerPrice=PRICE_CLOSE;   
      break;
      case 1:
         aUpperMode=MODE_OPEN;
         aLowerMode=MODE_OPEN; 
         aUpperPrice=PRICE_OPEN;
         aLowerPrice=PRICE_OPEN;             
      break;
      case 2:
         aUpperMode=MODE_HIGH;
         aLowerMode=MODE_LOW;    
         aUpperPrice=PRICE_HIGH;
         aLowerPrice=PRICE_LOW;              
      break;   
      case 3:
         aUpperMode=MODE_LOW;
         aLowerMode=MODE_HIGH;   
         aUpperPrice=PRICE_LOW;
         aLowerPrice=PRICE_HIGH;  
      break;     
   }
}

int fMADrawBegin(int aPeriod,int aMethod){
      switch(aMethod){
         case 1: return(10*aPeriod);
         case 2: return(20*aPeriod);      
      }
   return(aPeriod);    
}


